#ifndef MODEL_H
#define MODEL_H

#include <QAbstractItemModel>
#include <QGraphicsItem>

class TreeModel : public QAbstractItemModel
{
   // Q_OBJECT

   public:
      TreeModel (QGraphicsItem * root, QObject *parent = 0);
      ~TreeModel ();

      QVariant data (const QModelIndex & index, int role) const;
      Qt::ItemFlags flags (const QModelIndex & index) const;
      // QVariant headerData (int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
      QModelIndex index (int row, int column, const QModelIndex & parent = QModelIndex ()) const;
      QModelIndex parent (const QModelIndex & index) const;
      int rowCount (const QModelIndex & parent = QModelIndex ()) const;
      int columnCount (const QModelIndex & parent = QModelIndex ()) const;

      Qt::DropActions supportedDropActions () const;
      QStringList mimeTypes() const;
      bool dropMimeData (const QMimeData * data, Qt::DropAction action,
                         int row, int column, const QModelIndex & parent);

   private:
      QGraphicsItem * rootItem;
};

#endif // MODEL_H
